(function () {
    var app = angular.module('tsrc', ['ionic', 'ngCordova', 'tsrc.controllers', 'tsrc.constants', 'tsrc.services', 'tsrc.factories', 'jett.ionic.filter.bar']);
    app
        .run(function ($ionicPlatform) {
            $ionicPlatform.ready(function () {
                if (window.cordova && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                    cordova.plugins.Keyboard.disableScroll(true);
                }
                if (window.StatusBar) {
                    StatusBar.styleDefault();
                }
                setTimeout(function() {
                    navigator.splashscreen.hide();
                }, 300);
            });
        })
        .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
            $ionicConfigProvider.tabs.position("bottom");
            $stateProvider
                .state('app', {
                    url: '/tab',
                    abstract: true,
                    templateUrl: 'templates/tabs.html'
                })
                .state('app.casino', {
                    url: '/casino',
                    views: {
                        'tab-casino': {
                            templateUrl: 'templates/casino.html',
                            controller: 'CasinoCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.hotel', {
                    url: '/hotel',
                    views: {
                        'tab-hotel': {
                            templateUrl: 'templates/hotel.html',
                            controller: 'HotelCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.dining', {
                    url: '/dining',
                    views: {
                        'tab-dining': {
                            templateUrl: 'templates/dining.html',
                            controller: 'DiningCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.event', {
                    url: '/event',
                    views: {
                        'tab-event': {
                            templateUrl: 'templates/event.html',
                            controller: 'EventCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.amenity', {
                    url: '/amenity',
                    views: {
                        'tab-amenity': {
                            templateUrl: 'templates/amenity.html',
                            controller: 'AmenityCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.casinoDetail', {
                    url: '/casino/:id',
                    views: {
                        'tab-casino': {
                            templateUrl: 'templates/single.html',
                            controller: 'SingleCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.hotelDetail', {
                    url: '/hotel/:id',
                    views: {
                        'tab-hotel': {
                            templateUrl: 'templates/single.html',
                            controller: 'SingleCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.diningDetail', {
                    url: '/dining/:id',
                    views: {
                        'tab-dining': {
                            templateUrl: 'templates/single.html',
                            controller: 'SingleCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.eventDetail', {
                    url: '/event/:id/:date',
                    views: {
                        'tab-event': {
                            templateUrl: 'templates/single_event.html',
                            controller: 'SingleCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.amenityDetail', {
                    url: '/amenity/:id',
                    views: {
                        'tab-amenity': {
                            templateUrl: 'templates/single.html',
                            controller: 'SingleCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.search', {
                    url: '/search/:term/:page',
                    views: {
                        'tab-search': {
                            templateUrl: 'templates/search.html',
                            controller: 'SearchCtrl'
                        }
                    },
                    cache: false
                })
                .state('app.internet', {
                    url: '/internet',
                    views: {
                        'tab-internet': {
                            templateUrl: 'templates/internet.html',
                            controller: 'InternetCtrl'
                        }
                    },
                    cache: false
                });
            $urlRouterProvider.otherwise('/tab/casino');
        });
})();