(function () {
    var controllers = angular.module('tsrc.controllers', []);
    controllers
        .controller('MainCtrl', function ($ionicFilterBar, $scope, $state) {
            var filterBarInstance;
            $scope.showFilterBar = function () {
                filterBarInstance = $ionicFilterBar.show();
            };
            /**
             * A new form has been added to filter bar plugin core file
             */
            $scope.search = function () {
                $state.go('app.search', {term: $scope.data.filterText});
            };
        })
        .controller('SearchCtrl', function ($scope, Toast, SearchService, $stateParams, $ionicPlatform, $cordovaNetwork, $state) {
            $scope.searches = [];
            document.addEventListener("deviceready", function () {
                var type = $cordovaNetwork.getNetwork();
                var isOnline = $cordovaNetwork.isOnline();
                var isOffline = $cordovaNetwork.isOffline();
                if (!isOnline) {
                    $state.go('app.internet');
                }
            }, false);
            SearchService.getSearchList($stateParams.term).then(function (success) {
                angular.forEach(success, function (response) {
                    $scope.searches.push(response);
                });
            }, function () {
                Toast.show("No Results");
            });
        })
        .controller('CasinoCtrl', function ($scope, Toast, HomeService, ListService, $state, $ionicPlatform, $cordovaNetwork) {
            $scope.promotions = [];
            document.addEventListener("deviceready", function () {
                var type = $cordovaNetwork.getNetwork();
                var isOnline = $cordovaNetwork.isOnline();
                var isOffline = $cordovaNetwork.isOffline();
                if (!isOnline) {
                    $state.go('app.internet');
                }
            }, false);
            HomeService.getBanner().then(function (success) {
                $scope.home = success;
            }, function () {
                Toast.show("Sorry, We are unable to connect to the internet");
            });
            ListService.getList('promotion', 'all').then(function (success) {
                angular.forEach(success, function (response) {
                    $scope.promotions.push(response);
                });
            }, function () {
                Toast.show("Sorry, We are unable to connect to the internet");
            });
            /**
             * Maps
             */
            var latLng = new google.maps.LatLng(43.1158960, -75.5892920);
            var mapOptions = {
                center: latLng,
                zoom: 12,
                mapTypeId: google.maps.MapTypeId.ROADMAP,
                draggable: false,
                scrollwheel: false
            };
            var map = new google.maps.Map(document.getElementById("map"), mapOptions);
            new google.maps.Marker({
                position: latLng,
                map: map,
                title: 'Turning Stone Resort and Casino'
            });
            $scope.openInMaps = function () {
                var geoString = '';
                if (ionic.Platform.isIOS()) {
                    geoString = 'maps://?q=43.1158960,-75.5892920';
                }
                else if (ionic.Platform.isAndroid()) {
                    geoString = 'geo://?q=43.1158960,-75.5892920';
                }
                window.open(geoString, '_system');
            };
            $scope.openInTelephone = function (telephone) {
                window.open('tel:+1' + telephone, '_system');
            };
        })
        .controller('HotelCtrl', function ($scope, Toast, ListService, $ionicPlatform, $cordovaNetwork, $state) {
            document.addEventListener("deviceready", function () {
                var type = $cordovaNetwork.getNetwork();
                var isOnline = $cordovaNetwork.isOnline();
                var isOffline = $cordovaNetwork.isOffline();
                if (!isOnline) {
                    $state.go('app.internet');
                }
            }, false);
            $scope.hotels = [];
            ListService.getList('hotel', 'all').then(function (success) {
                angular.forEach(success, function (response) {
                    $scope.hotels.push(response);
                });
            }, function () {
                Toast.show("Sorry, We are unable to connect to the internet");
            });
        })
        .controller('DiningCtrl', function ($scope, Toast, ListService, $state, $ionicPlatform, $cordovaNetwork) {
            document.addEventListener("deviceready", function () {
                var type = $cordovaNetwork.getNetwork();
                var isOnline = $cordovaNetwork.isOnline();
                var isOffline = $cordovaNetwork.isOffline();
                if (!isOnline) {
                    $state.go('app.internet');
                }
            }, false);
            $scope.dinings = [];
            ListService.getList('dining', 'all').then(function (success) {
                angular.forEach(success, function (response) {
                    $scope.dinings.push(response);
                });
            }, function () {
                Toast.show("Sorry, We are unable to connect to the internet");
            });
        })
        .controller('EventCtrl', function ($scope, ListService, $state, $ionicPlatform, $cordovaNetwork) {
            document.addEventListener("deviceready", function () {
                var type = $cordovaNetwork.getNetwork();
                var isOnline = $cordovaNetwork.isOnline();
                var isOffline = $cordovaNetwork.isOffline();
                if (!isOnline) {
                    $state.go('app.internet');
                }
            }, false);
            var page = 1;
            var moreEventsCanBeLoaded = true;
            $scope.events = [];
            $scope.loadMoreEvents = function () {
                ListService.getList('event', page).then(function (success) {
                    page++;
                    angular.forEach(success, function (response) {
                        $scope.events.push(response);
                    });
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }, function () {
                    moreEventsCanBeLoaded = false;
                });
            };
            $scope.moreEventsCanBeLoaded = function () {
                return moreEventsCanBeLoaded;
            };
            $scope.loadMoreEvents();
        })
        .controller('AmenityCtrl', function ($scope, Toast, ListService, $state, $ionicPlatform, $cordovaNetwork) {
            document.addEventListener("deviceready", function () {
                var type = $cordovaNetwork.getNetwork();
                var isOnline = $cordovaNetwork.isOnline();
                var isOffline = $cordovaNetwork.isOffline();
                if (!isOnline) {
                    $state.go('app.internet');
                }
            }, false);
            $scope.amenities = [];
            ListService.getList('amenity', 'all').then(function (success) {
                angular.forEach(success, function (response) {
                    $scope.amenities.push(response);
                });
            }, function () {
                Toast.show("Sorry, We are unable to connect to the internet");
            });
        })
        .controller('SingleCtrl', function ($scope, $stateParams, SingleService, Toast, $location, HomeService, $ionicPlatform, $cordovaNetwork, $state) {
            document.addEventListener("deviceready", function () {
                var type = $cordovaNetwork.getNetwork();
                var isOnline = $cordovaNetwork.isOnline();
                var isOffline = $cordovaNetwork.isOffline();
                if (!isOnline) {
                    $state.go('app.internet');
                }
            }, false);
            $scope.openInTelephone = function (telephone) {
                window.open('tel:+1' + telephone, '_system');
            };
            $scope.home = [];
            $scope.home['mobile'] = null;
            if ($location.path().indexOf('casino') !== -1) {
                SingleService.getSinglePromotion($stateParams.id).then(function (response) {
                    $scope.submenu = response[0];
                }, function () {
                    Toast.show("Sorry, We are unable to connect to the internet");
                });
            }
            else if ($location.path().indexOf('event') !== -1) {
                SingleService.getSingleEvent($stateParams.id).then(function (response) {
                    $scope.event = response;
                    $scope.date = $stateParams.date;
                }, function () {
                    Toast.show("Sorry, We are unable to connect to the internet");
                });
            }
            else {
                HomeService.getBanner().then(function (success) {
                    $scope.home = success;
                }, function (error) {
                    Toast.show("Sorry, We are unable to connect to the internet");
                });
                SingleService.getSingleSubmenu($stateParams.id).then(function (response) {
                    $scope.submenu = response[0];
                }, function () {
                    Toast.show("Sorry, We are unable to connect to the internet");
                });
            }
        })
        .controller('InternetCtrl', function ($ionicHistory, $scope) {
            $scope.goBack = function () {
                $ionicHistory.goBack();
            };
        })
})();
