(function () {
    var factories = angular.module('tsrc.factories', []);
    factories
    /**
     * Loader Factory
     */
        .factory('Loader', function ($ionicLoading) {
            var show = function () {
                var template;
                if (ionic.Platform.isIOS()) {
                    template = '<ion-spinner icon="ios"></ion-spinner>';
                }
                else if (ionic.Platform.isAndroid()) {
                    template = '<ion-spinner icon="android"></ion-spinner>';
                }
                else {
                    template = '<ion-spinner icon="spiral"></ion-spinner>';
                }
                $ionicLoading.show({
                    template: template,
                    hideOnStateChange: true
                });
            };
            var hide = function () {
                $ionicLoading.hide();
            };
            return {
                hide: hide,
                show: show
            }
        })
        /**
         * Factory to show toast messages with a popup fall back if Toast not supported
         */
        .factory('Toast', function ($rootScope, $timeout, $ionicPopup, $cordovaToast) {
            return {
                show: function (message, duration, position) {
                    message = message || "There was a problem...";
                    duration = duration || 'long';
                    position = position || 'center';
                    if (!!window.cordova) {
                        $cordovaToast.show(message, duration, position);
                    }
                    else {
                        $ionicPopup.alert({
                            template: message
                        });
                    }
                }
            };
        })
})();
