(function () {
    var services = angular.module('tsrc.services', []);
    services
        .service('HomeService', function ($http, API, $q, Loader) {
            var home = {};
            home.getBanner = function () {
                return $q(function (resolve, reject) {
                    Loader.show();
                    $http.get(API.url + '/home' + '?q=' + Math.random()).then(function (success) {
                        Loader.hide();
                        resolve(success.data);
                    }, function (error) {
                        Loader.hide();
                        reject(error.status);
                    });
                });
            };
            return home;
        })
        .service('ListService', function ($http, API, $q, Loader) {
            var lists = {};
            lists.getList = function (type, page) {
                return $q(function (resolve, reject) {
                    Loader.show();
                    $http.get(API.url + '/' + type + '/list/' + page + '?q=' + Math.random()).then(function (success) {
                        Loader.hide();
                        resolve(success.data);
                    }, function (error) {
                        Loader.hide();
                        reject(error.status);
                    });
                });
            };
            return lists;
        })
        .service('SearchService', function ($http, API, $q, Loader) {
            var searches = {};
            searches.getSearchList = function (term) {
                return $q(function (resolve, reject) {
                    Loader.show();
                    $http.get(API.url + '/search/' + term + '/all' + '?q=' + Math.random()).then(function (success) {
                        Loader.hide();
                        resolve(success.data);
                    }, function (error) {
                        Loader.hide();
                        reject('Sorry! No more results found');
                    });
                });
            };
            return searches;
        })
        .service('SingleService', function ($http, API, $q, Loader) {
            var single = {};
            single.getSingleSubmenu = function (id) {
                return $q(function (resolve, reject) {
                    Loader.show();
                    $http.get(API.url + '/submenu/' + id + '?q=' + Math.random()).then(function (success) {
                        Loader.hide();
                        resolve(success.data);
                    }, function (error) {
                        Loader.hide();
                        reject(error.status);
                    });
                });
            };
            single.getSinglePromotion = function (id) {
                return $q(function (resolve, reject) {
                    Loader.show();
                    $http.get(API.url + '/promotion/' + id + '?q=' + Math.random()).then(function (success) {
                        Loader.hide();
                        resolve(success.data);
                    }, function (error) {
                        Loader.hide();
                        reject(error.status);
                    });
                });
            };
            single.getSingleEvent = function (id) {
                return $q(function (resolve, reject) {
                    Loader.show();
                    $http.get(API.url + '/event/' + id + '?q=' + Math.random()).then(function (success) {
                        Loader.hide();
                        resolve(success.data);
                    }, function (error) {
                        Loader.hide();
                        reject(error.status);
                    });
                });
            };
            return single;
        })
})();